[Caption: Listing 5 -- Detecting unimplemented functionality]

void PushVarCString( C_object* InObject,
                     char* Buffer,
                     int BufferSize,
                     char **Address )
{
  if( TextLength( InObject ) < BufferSize )
  {
    ObjectToCString( InObject, Buffer, BufferSize );
    *Address = Buffer;
  }
  else
  {
    assert( "Long C strings not yet implemented" == NULL );

    // Handle gracefully as temporary measure.
    // Replace later with real implementation.

    ObjectToCString( InObject, Buffer, BufferSize );
    *Address = Buffer;
  }
}
